<?php

namespace app\admin\model;

use think\Model;
use think\Db;

class Company extends Model
{

    

    

    // 表名
    protected $name = 'company';
    
    // 自动写入时间戳字段
    protected $autoWriteTimestamp = 'integer';

    // 定义时间戳字段名
    protected $createTime = 'createtime';
    protected $updateTime = 'updatetime';
    protected $deleteTime = false;

    // 追加属性
    protected $append = [
        'status_text',
        'is_open_text'
    ];



protected static function init()
{
    self::beforeInsert(function ($row) {
        if(isset($row['area_id'])) {
            $areaData = Db::name('shopro_area')->where('id',$row['area_id'])->find();
            $row['province_name'] = $areaData['province_name'];
            $row['city_name'] = $areaData['city_name'];
            $row['area_name'] = $areaData['name'];
            $row['full_address'] = $row['province_name'].$row['city_name'].$row['area_name'].$row['address'];
        }
    });

    self::afterInsert(function ($row) {
        $data = [
            'user_id' => $row['id'],
        ];
        Db::name('company_wallet')->insertGetId($data);
    });

    self::beforeUpdate(function ($row) {
        if(isset($row['area_id'])) {
            $areaData = Db::name('shopro_area')->where('id',$row['area_id'])->find();
            $row['province_name'] = $areaData['province_name'];
            $row['city_name'] = $areaData['city_name'];
            $row['area_name'] = $areaData['name'];
            $row['full_address'] = $row['province_name'].$row['city_name'].$row['area_name'].$row['address'];
        }
    });
}
    

    
    public function getStatusList()
    {
        return ['-1' => __('Status -1'), '0' => __('Status 0'), '1' => __('Status 1'), '2' => __('Status 2')];
    }

    public function getIsOpenList()
    {
        return ['0' => __('Is_open 0'), '1' => __('Is_open 1')];
    }


    public function getStatusTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['status']) ? $data['status'] : '');
        $list = $this->getStatusList();
        return isset($list[$value]) ? $list[$value] : '';
    }


    public function getIsOpenTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['is_open']) ? $data['is_open'] : '');
        $list = $this->getIsOpenList();
        return isset($list[$value]) ? $list[$value] : '';
    }




    public function wallet()
    {
        return $this->belongsTo('app\admin\model\Companywallet', 'id', 'user_id', [], 'LEFT')->setEagerlyType(0);
    }
}
